#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityFeedBackGiftCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityFeedBackGiftCFG> M_ActivityFeedBackGiftCFG::msSingleton(nullptr);

int M_ActivityFeedBackGiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFeedBackGiftCFGData* M_ActivityFeedBackGiftCFG::GetData(int VipLv)
{
	auto it = mMapData.find(VipLv);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityFeedBackGiftCFGData>& M_ActivityFeedBackGiftCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityFeedBackGiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityFeedBackGiftCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFeedBackGiftCFGData data;
		data.mVipLv = element->IntAttribute("VipLv");
		{
			const char* Gear1 = element->Attribute("Gear1");
			std::vector<std::string> vecGear1;
			boost::split(vecGear1, Gear1, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGear1.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGear1[i].c_str(), &temp))
				{
					data.mGear1.push_back(temp);
				}
			}
		}
		{
			const char* Gear2 = element->Attribute("Gear2");
			std::vector<std::string> vecGear2;
			boost::split(vecGear2, Gear2, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGear2.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGear2[i].c_str(), &temp))
				{
					data.mGear2.push_back(temp);
				}
			}
		}
		{
			const char* Gear3 = element->Attribute("Gear3");
			std::vector<std::string> vecGear3;
			boost::split(vecGear3, Gear3, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGear3.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGear3[i].c_str(), &temp))
				{
					data.mGear3.push_back(temp);
				}
			}
		}
		{
			const char* Gear4 = element->Attribute("Gear4");
			std::vector<std::string> vecGear4;
			boost::split(vecGear4, Gear4, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGear4.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGear4[i].c_str(), &temp))
				{
					data.mGear4.push_back(temp);
				}
			}
		}
		{
			const char* Gear5 = element->Attribute("Gear5");
			std::vector<std::string> vecGear5;
			boost::split(vecGear5, Gear5, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGear5.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGear5[i].c_str(), &temp))
				{
					data.mGear5.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mVipLv) != mMapData.end())std::cout <<"data refind:" << data.mVipLv << std::endl;
		assert(mMapData.find(data.mVipLv) == mMapData.end());
		mMapData.insert(std::make_pair(data.mVipLv, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityFeedBackGiftCFG::Load()
{
	Load("../Config/M_ActivityFeedBackGiftCFG.xml");
}

M_ActivityFeedBackGiftCFG* M_ActivityFeedBackGiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFeedBackGiftCFG());
	}
	return msSingleton.get();
}
